# --------------------------------------------------------
#
# Tiki Table for outbound URL translations
# (useful for search engine friendly URLs etc)
# Outbound translations adjust the HTML sent to the user.
#
# regexid - Used to uniquely identify this row in the list
#           (and to order the execution of the regexes)
# regex_left - the left part of the regex (ie. s/left/right/)
# regex_right - like left, but right ;-)
# regex_flags - things like "g", "m" etc (ie. global, multiline)
# continue_flag - Continue processing if match found/not found?
# comment_text - allows the admin somewhere to document whats what
#
drop table if exists tiki_urlt_regex_out;
create table tiki_urlt_regex_out
(
	regexid int(14) NOT NULL,
	regex_left varchar(200) default null,
	regex_right varchar(200) default null,
	regex_flags varchar(80) default null,
	continue_flag char(1) default null,
	comment_text varchar(255) default null,
	PRIMARY KEY (regexid)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
#
# Tiki Table for incoming URL translations
# (useful for search engine friendly URLs etc)
# Incoming translations adjust requests from the user
#
# Has same columns as tiki_urlt_regex_out
#
drop table if exists tiki_urlt_regex_in;
create table tiki_urlt_regex_in
(
	regexid int(14) NOT NULL,
	regex_left varchar(200) default null,
	regex_right varchar(200) default null,
	regex_flags varchar(80) default null,
	continue_flag char(1) default null,
	comment_text varchar(255) default null,
	PRIMARY KEY (regexid)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
# --------------------------------------------------------
#
# Tiki Table for configuring URLt
# Stores a series of key/value pairs of type text or integer
#
drop table if exists tiki_urlt_config;
create table tiki_urlt_config
(
	configid int(4) NOT NULL auto_increment,
	config_key varchar(200) default null,
	config_value_text varchar(200) default null,
	config_value_int int(14) default null,
	PRIMARY KEY(configid)
) TYPE=MyISAM AUTO_INCREMENT=1 ;
#
# Setup relly basic MIME Types (defaults to a configurable value or text/plain)
#
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_html','text/html');
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_gif','image/gif');
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_png','image/png');
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_jpg','image/jpeg');
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_jpeg','image/jpeg');
INSERT INTO tiki_urlt_config (config_key,config_value_text) VALUES ('extension_ico','icon/x-icon');
# --------------------------------------------------------
