<?php

// tiki-edit_urlt_in.php - Edit Incoming URL translations
// This file: (c) 2004 Ralph Bolton (Licensed like Tiki)
// Find me at http://www.coofercat.com/

// Initialisation
require_once ('tiki-setup.php');
require_once ('lib/urlt/urltlib.php');

// URLt is not implemented as a "Tiki feature" yet. When it is, reinstate this code.
//if ($feature_urlt != 'y') {
//	$smarty->assign('msg', tra("This feature is disabled").": feature_urlt");

//	$smarty->display("error.tpl");
//	die;
//}

// URLt does not have a permissions model yet, so we just check if user is an admin
// (which is cheesy). Reinstate this code when the tiki_p_edit_urlt permission (and
// associated editing capability) has been created in Tiki itself.
// Now check permissions to access this page
//if ($tiki_p_edit_urlt != 'y') {
//	$smarty->assign('msg', tra("Permission denied you cannot administer URL translations"));

//	$smarty->display("error.tpl");
//	die;
//}

if($tiki_p_admin != 'y')
{
	$smarty->assign('msg', tra("Permission denied you cannot administer URL translations"));
	$smarty->display("error.tpl");
	die;
}

// See if we're writing to the DB or not...
if($_SERVER['REQUEST_METHOD'] == 'POST')
{
	$out_msg="";
	$configid_list=array();
	$extension_list=array();
	$mimetype_list=array();

	// Process posted information
	if(isset($_POST['configid']))
	{
		$configid_list=$_POST['configid'];
	}
	if(isset($_POST['extension']))
	{
		$extension_list=$_POST['extension'];
	}
	if(isset($_POST['mimetype']))
	{
		$mimetype_list=$_POST['mimetype'];
	}
        if((isset($_POST['urlt_in_enabled'])) && ($_POST['urlt_in_enabled'] == "yes"))
        {
                urlt_update_config('urlt_in_enabled',1);
        }
	else
	{
		urlt_update_config('urlt_in_enabled',0);
	}
        if((isset($_POST['urlt_out_enabled'])) && ($_POST['urlt_out_enabled'] == "yes"))
        {
                urlt_update_config('urlt_out_enabled',1);
        }
        else
        {
                urlt_update_config('urlt_out_enabled',0);
        }
        if(isset($_POST['urlt_in_cache_time']))
        {
                $cache_time=$_POST['urlt_in_cache_time'];
                $cache_time=preg_replace('/\D/','',$cache_time);
                $cache_time=$cache_time + 0;
                urlt_update_config('urlt_in_cache_time',$cache_time);
        }
        if(isset($_POST['urlt_out_cache_time']))
        {
                $cache_time=$_POST['urlt_out_cache_time'];
                $cache_time=preg_replace('/\D/','',$cache_time);
                $cache_time=$cache_time + 0;
                urlt_update_config('urlt_out_cache_time',$cache_time);
        }
	if(isset($_POST['urlt_in_notfound_page']))
	{
		urlt_update_config('urlt_in_notfound_page',$_POST['urlt_in_notfound_page'],'text');
	}
	if(isset($_POST['urlt_in_error_page']))
	{
		urlt_update_config('urlt_in_error_page',$_POST['urlt_in_error_page'],'text');
	}
	if(isset($_POST['urlt_in_default_mime']))
	{
		urlt_update_config('urlt_in_default_mime',$_POST['urlt_in_default_mime'],'text');
	}

	$lines=array();
	$id=0;
	foreach (array_keys($extension_list) as $item)
	{
		if(isset($configid_list[$item]))
		{
			$id=$configid_list[$item];
		}
		else
		{
			continue;
		}
		if((isset($_POST['delete_'.$id])) && ($_POST['delete_'.$id] == "yes"))
		{
			// User wants to delete this line...
			if($tikilib->db->Execute("delete from tiki_urlt_config where configid=?", array($id)) === false)
			{
				$out_msg="Error deleting line $id from config database: " . $tikilib->db->ErrorMsg();
				break;
			}
		}
		else
		{
			$ext="extension_" . strtolower($extension_list[$item]);
			if($tikilib->db->Execute("update tiki_urlt_config set config_key=?, config_value_text=? where configid=?", array($ext,$mimetype_list[$item],$id)) === false)
			{
				$out_msg="Error updating data in database for ID $id: " . $tikilib->db->ErrorMsg();
				break;
			}
		}
	}

	// Now check for new entry..
	if((isset($_POST['extension_new'])) && (isset($_POST['mimetype_new'])) &&
		($_POST['extension_new'] != "") && ($_POST['mimetype_new'] != ""))
	{
		// Okay to add!
		$ext="extension_" . $_POST['extension_new'];

		if($tikilib->db->Execute("insert into tiki_urlt_config (config_key,config_value_text) values (?,?);",array($ext,$_POST['mimetype_new']))===false)
		{
			$out_msg="Error adding new entry to config database: " . $tikilib->db->ErrorMsg();
		}
	}


	$smarty->assign('urlt_message',$out_msg);
}

// First, get the config that this form uses...

$smarty->assign('urlt_in_cache_time',urlt_get_config_value($tikilib->db,'urlt_in_cache_time'));
$smarty->assign('urlt_in_enabled',urlt_get_config_value($tikilib->db,'urlt_in_enabled'));
$smarty->assign('urlt_in_notfound_page',urlt_get_config_value($tikilib->db,'urlt_in_notfound_page','text'));
$smarty->assign('urlt_in_error_page',urlt_get_config_value($tikilib->db,'urlt_in_error_page','text'));
$smarty->assign('urlt_in_default_mime',urlt_get_config_value($tikilib->db,'urlt_in_default_mime','text'));

$smarty->assign('urlt_out_cache_time',urlt_get_config_value($tikilib->db,'urlt_out_cache_time'));
$smarty->assign('urlt_out_enabled',urlt_get_config_value($tikilib->db,'urlt_out_enabled'));

// Now (re)display the contents of the database table
$rs=0;
if(($rs=$tikilib->db->Execute("select * from tiki_urlt_config where config_key like 'extension_%'")) === false)
{
	$smarty->assign('urlt_message',"Failed to read database: " . $tikilib->db->ErrorMsg());
}
else
{
	$urlt_entries=array();
	$highest=1;
	while($array = $rs->FetchRow())
	{
		$ext=preg_replace('/^extension_/','',$array['config_key']);
                $array['extension']=htmlentities($ext);
                $array['mimetype']=htmlentities($array['config_value_text']);
		$urlt_entries[]=$array;
	}
	$smarty->assign_by_ref('urlt_mime_types',$urlt_entries);
}
$smarty->assign('title',"Administer URLt");

// Display the Template
$smarty->assign('mid', 'tiki-urlt_admin.tpl');
$smarty->assign('show_page_bar', 'n');
$smarty->display("tiki.tpl");

?>
